/* Utils.c generated by valac 0.42.3, the Vala compiler
 * generated from Utils.vala, do not modify */

/*-
 * Copyright (c) 2014-2018 elementary LLC.
 *
 * This software is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this software; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301, USA.
 *
 * Authored by: Corentin Noël <corentin@elementary.io>
 */


#include <glib.h>
#include <glib-object.h>
#include <gdk/gdk.h>
#include <gee.h>
#include <float.h>
#include <math.h>

#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define DISPLAY_TYPE_MONITOR (display_monitor_get_type ())
#define DISPLAY_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DISPLAY_TYPE_MONITOR, DisplayMonitor))
#define DISPLAY_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DISPLAY_TYPE_MONITOR, DisplayMonitorClass))
#define DISPLAY_IS_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DISPLAY_TYPE_MONITOR))
#define DISPLAY_IS_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DISPLAY_TYPE_MONITOR))
#define DISPLAY_MONITOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DISPLAY_TYPE_MONITOR, DisplayMonitorClass))

typedef struct _DisplayMonitor DisplayMonitor;
typedef struct _DisplayMonitorClass DisplayMonitorClass;

#define DISPLAY_TYPE_MONITOR_MODE (display_monitor_mode_get_type ())
#define DISPLAY_MONITOR_MODE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DISPLAY_TYPE_MONITOR_MODE, DisplayMonitorMode))
#define DISPLAY_MONITOR_MODE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DISPLAY_TYPE_MONITOR_MODE, DisplayMonitorModeClass))
#define DISPLAY_IS_MONITOR_MODE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DISPLAY_TYPE_MONITOR_MODE))
#define DISPLAY_IS_MONITOR_MODE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DISPLAY_TYPE_MONITOR_MODE))
#define DISPLAY_MONITOR_MODE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DISPLAY_TYPE_MONITOR_MODE, DisplayMonitorModeClass))

typedef struct _DisplayMonitorMode DisplayMonitorMode;
typedef struct _DisplayMonitorModeClass DisplayMonitorModeClass;



gboolean display_utils_has_touchscreen (void);
GType display_monitor_get_type (void) G_GNUC_CONST;
GType display_monitor_mode_get_type (void) G_GNUC_CONST;
GeeLinkedList* display_utils_get_common_monitor_modes (GeeLinkedList* monitors);
gdouble display_utils_get_min_compatible_scale (GeeLinkedList* monitors);
GeeLinkedList* display_monitor_get_modes (DisplayMonitor* self);
gdouble* display_monitor_mode_get_supported_scales (DisplayMonitorMode* self,
                                                    int* result_length1);
static gboolean _vala_double_array_contains (gdouble * stack,
                                      int stack_length,
                                      gdouble needle);
gint display_monitor_mode_get_width (DisplayMonitorMode* self);
gint display_monitor_mode_get_height (DisplayMonitorMode* self);
gdouble display_monitor_get_max_scale (DisplayMonitor* self);


static gpointer
_g_object_ref0 (gpointer self)
{
#line 26 "../src/Utils.vala"
	return self ? g_object_ref (self) : NULL;
#line 79 "Utils.c"
}


gboolean
display_utils_has_touchscreen (void)
{
	gboolean result = FALSE;
	GdkDisplay* display = NULL;
	GdkDisplay* _tmp0_;
	GdkDisplay* _tmp1_;
#line 24 "../src/Utils.vala"
	_tmp0_ = gdk_display_get_default ();
#line 24 "../src/Utils.vala"
	display = _tmp0_;
#line 25 "../src/Utils.vala"
	_tmp1_ = display;
#line 25 "../src/Utils.vala"
	if (_tmp1_ != NULL) {
#line 98 "Utils.c"
		GdkDeviceManager* manager = NULL;
		GdkDisplay* _tmp2_;
		GdkDeviceManager* _tmp3_;
		GdkDeviceManager* _tmp4_;
		GList* devices = NULL;
		GdkDeviceManager* _tmp5_;
		GList* _tmp6_;
		GList* _tmp7_;
#line 26 "../src/Utils.vala"
		_tmp2_ = display;
#line 26 "../src/Utils.vala"
		_tmp3_ = gdk_display_get_device_manager (_tmp2_);
#line 26 "../src/Utils.vala"
		_tmp4_ = _g_object_ref0 (_tmp3_);
#line 26 "../src/Utils.vala"
		manager = _tmp4_;
#line 27 "../src/Utils.vala"
		_tmp5_ = manager;
#line 27 "../src/Utils.vala"
		_tmp6_ = gdk_device_manager_list_devices (_tmp5_, GDK_DEVICE_TYPE_SLAVE);
#line 27 "../src/Utils.vala"
		devices = _tmp6_;
#line 28 "../src/Utils.vala"
		_tmp7_ = devices;
#line 123 "Utils.c"
		{
			GList* device_collection = NULL;
			GList* device_it = NULL;
#line 28 "../src/Utils.vala"
			device_collection = _tmp7_;
#line 28 "../src/Utils.vala"
			for (device_it = device_collection; device_it != NULL; device_it = device_it->next) {
#line 131 "Utils.c"
				GdkDevice* device = NULL;
#line 28 "../src/Utils.vala"
				device = (GdkDevice*) device_it->data;
#line 135 "Utils.c"
				{
					GdkDevice* _tmp8_;
					GdkInputSource _tmp9_;
					GdkInputSource _tmp10_;
#line 29 "../src/Utils.vala"
					_tmp8_ = device;
#line 29 "../src/Utils.vala"
					g_object_get (_tmp8_, "input-source", &_tmp9_, NULL);
#line 29 "../src/Utils.vala"
					_tmp10_ = _tmp9_;
#line 29 "../src/Utils.vala"
					if (_tmp10_ == GDK_SOURCE_TOUCHSCREEN) {
#line 30 "../src/Utils.vala"
						result = TRUE;
#line 30 "../src/Utils.vala"
						(devices == NULL) ? NULL : (devices = (g_list_free (devices), NULL));
#line 30 "../src/Utils.vala"
						_g_object_unref0 (manager);
#line 30 "../src/Utils.vala"
						return result;
#line 156 "Utils.c"
					}
				}
			}
		}
#line 25 "../src/Utils.vala"
		(devices == NULL) ? NULL : (devices = (g_list_free (devices), NULL));
#line 25 "../src/Utils.vala"
		_g_object_unref0 (manager);
#line 165 "Utils.c"
	}
#line 35 "../src/Utils.vala"
	result = FALSE;
#line 35 "../src/Utils.vala"
	return result;
#line 171 "Utils.c"
}


static gboolean
_vala_double_array_contains (gdouble * stack,
                             int stack_length,
                             gdouble needle)
{
	int i;
#line 45 "../src/Utils.vala"
	for (i = 0; i < stack_length; i++) {
#line 45 "../src/Utils.vala"
		if (needle == stack[i]) {
#line 45 "../src/Utils.vala"
			return TRUE;
#line 187 "Utils.c"
		}
	}
#line 45 "../src/Utils.vala"
	return FALSE;
#line 192 "Utils.c"
}


GeeLinkedList*
display_utils_get_common_monitor_modes (GeeLinkedList* monitors)
{
	GeeLinkedList* result = NULL;
	GeeLinkedList* common_modes = NULL;
	GeeLinkedList* _tmp0_;
	gdouble min_scale = 0.0;
	gboolean first_monitor = FALSE;
#line 38 "../src/Utils.vala"
	g_return_val_if_fail (monitors != NULL, NULL);
#line 39 "../src/Utils.vala"
	_tmp0_ = gee_linked_list_new (DISPLAY_TYPE_MONITOR_MODE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 39 "../src/Utils.vala"
	common_modes = _tmp0_;
#line 40 "../src/Utils.vala"
	min_scale = display_utils_get_min_compatible_scale (monitors);
#line 41 "../src/Utils.vala"
	first_monitor = TRUE;
#line 214 "Utils.c"
	{
		GeeLinkedList* _monitor_list = NULL;
		GeeLinkedList* _tmp1_;
		gint _monitor_size = 0;
		GeeLinkedList* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gint _monitor_index = 0;
#line 42 "../src/Utils.vala"
		_tmp1_ = _g_object_ref0 (monitors);
#line 42 "../src/Utils.vala"
		_monitor_list = _tmp1_;
#line 42 "../src/Utils.vala"
		_tmp2_ = _monitor_list;
#line 42 "../src/Utils.vala"
		_tmp3_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp2_);
#line 42 "../src/Utils.vala"
		_tmp4_ = _tmp3_;
#line 42 "../src/Utils.vala"
		_monitor_size = _tmp4_;
#line 42 "../src/Utils.vala"
		_monitor_index = -1;
#line 42 "../src/Utils.vala"
		while (TRUE) {
#line 239 "Utils.c"
			gint _tmp5_;
			gint _tmp6_;
			gint _tmp7_;
			DisplayMonitor* monitor = NULL;
			GeeLinkedList* _tmp8_;
			gint _tmp9_;
			gpointer _tmp10_;
			gboolean _tmp11_;
#line 42 "../src/Utils.vala"
			_tmp5_ = _monitor_index;
#line 42 "../src/Utils.vala"
			_monitor_index = _tmp5_ + 1;
#line 42 "../src/Utils.vala"
			_tmp6_ = _monitor_index;
#line 42 "../src/Utils.vala"
			_tmp7_ = _monitor_size;
#line 42 "../src/Utils.vala"
			if (!(_tmp6_ < _tmp7_)) {
#line 42 "../src/Utils.vala"
				break;
#line 260 "Utils.c"
			}
#line 42 "../src/Utils.vala"
			_tmp8_ = _monitor_list;
#line 42 "../src/Utils.vala"
			_tmp9_ = _monitor_index;
#line 42 "../src/Utils.vala"
			_tmp10_ = gee_abstract_list_get ((GeeAbstractList*) _tmp8_, _tmp9_);
#line 42 "../src/Utils.vala"
			monitor = (DisplayMonitor*) _tmp10_;
#line 43 "../src/Utils.vala"
			_tmp11_ = first_monitor;
#line 43 "../src/Utils.vala"
			if (_tmp11_) {
#line 274 "Utils.c"
				{
					GeeLinkedList* _mode_list = NULL;
					DisplayMonitor* _tmp12_;
					GeeLinkedList* _tmp13_;
					GeeLinkedList* _tmp14_;
					GeeLinkedList* _tmp15_;
					gint _mode_size = 0;
					GeeLinkedList* _tmp16_;
					gint _tmp17_;
					gint _tmp18_;
					gint _mode_index = 0;
#line 44 "../src/Utils.vala"
					_tmp12_ = monitor;
#line 44 "../src/Utils.vala"
					_tmp13_ = display_monitor_get_modes (_tmp12_);
#line 44 "../src/Utils.vala"
					_tmp14_ = _tmp13_;
#line 44 "../src/Utils.vala"
					_tmp15_ = _g_object_ref0 (_tmp14_);
#line 44 "../src/Utils.vala"
					_mode_list = _tmp15_;
#line 44 "../src/Utils.vala"
					_tmp16_ = _mode_list;
#line 44 "../src/Utils.vala"
					_tmp17_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp16_);
#line 44 "../src/Utils.vala"
					_tmp18_ = _tmp17_;
#line 44 "../src/Utils.vala"
					_mode_size = _tmp18_;
#line 44 "../src/Utils.vala"
					_mode_index = -1;
#line 44 "../src/Utils.vala"
					while (TRUE) {
#line 308 "Utils.c"
						gint _tmp19_;
						gint _tmp20_;
						gint _tmp21_;
						DisplayMonitorMode* mode = NULL;
						GeeLinkedList* _tmp22_;
						gint _tmp23_;
						gpointer _tmp24_;
						gdouble _tmp25_;
						DisplayMonitorMode* _tmp26_;
						gdouble* _tmp27_;
						gint _tmp27__length1;
						gdouble* _tmp28_;
						gint _tmp28__length1;
#line 44 "../src/Utils.vala"
						_tmp19_ = _mode_index;
#line 44 "../src/Utils.vala"
						_mode_index = _tmp19_ + 1;
#line 44 "../src/Utils.vala"
						_tmp20_ = _mode_index;
#line 44 "../src/Utils.vala"
						_tmp21_ = _mode_size;
#line 44 "../src/Utils.vala"
						if (!(_tmp20_ < _tmp21_)) {
#line 44 "../src/Utils.vala"
							break;
#line 334 "Utils.c"
						}
#line 44 "../src/Utils.vala"
						_tmp22_ = _mode_list;
#line 44 "../src/Utils.vala"
						_tmp23_ = _mode_index;
#line 44 "../src/Utils.vala"
						_tmp24_ = gee_abstract_list_get ((GeeAbstractList*) _tmp22_, _tmp23_);
#line 44 "../src/Utils.vala"
						mode = (DisplayMonitorMode*) _tmp24_;
#line 45 "../src/Utils.vala"
						_tmp25_ = min_scale;
#line 45 "../src/Utils.vala"
						_tmp26_ = mode;
#line 45 "../src/Utils.vala"
						_tmp27_ = display_monitor_mode_get_supported_scales (_tmp26_, &_tmp27__length1);
#line 45 "../src/Utils.vala"
						_tmp28_ = _tmp27_;
#line 45 "../src/Utils.vala"
						_tmp28__length1 = _tmp27__length1;
#line 45 "../src/Utils.vala"
						if (_vala_double_array_contains (_tmp28_, _tmp28__length1, _tmp25_)) {
#line 356 "Utils.c"
							GeeLinkedList* _tmp29_;
							DisplayMonitorMode* _tmp30_;
#line 46 "../src/Utils.vala"
							_tmp29_ = common_modes;
#line 46 "../src/Utils.vala"
							_tmp30_ = mode;
#line 46 "../src/Utils.vala"
							gee_abstract_collection_add ((GeeAbstractCollection*) _tmp29_, _tmp30_);
#line 365 "Utils.c"
						}
#line 44 "../src/Utils.vala"
						_g_object_unref0 (mode);
#line 369 "Utils.c"
					}
#line 44 "../src/Utils.vala"
					_g_object_unref0 (_mode_list);
#line 373 "Utils.c"
				}
#line 50 "../src/Utils.vala"
				first_monitor = FALSE;
#line 377 "Utils.c"
			} else {
				GeeLinkedList* to_remove = NULL;
				GeeLinkedList* _tmp31_;
				GeeLinkedList* _tmp72_;
				GeeLinkedList* _tmp73_;
#line 52 "../src/Utils.vala"
				_tmp31_ = gee_linked_list_new (DISPLAY_TYPE_MONITOR_MODE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 52 "../src/Utils.vala"
				to_remove = _tmp31_;
#line 387 "Utils.c"
				{
					GeeLinkedList* _mode_to_check_list = NULL;
					GeeLinkedList* _tmp32_;
					GeeLinkedList* _tmp33_;
					gint _mode_to_check_size = 0;
					GeeLinkedList* _tmp34_;
					gint _tmp35_;
					gint _tmp36_;
					gint _mode_to_check_index = 0;
#line 53 "../src/Utils.vala"
					_tmp32_ = common_modes;
#line 53 "../src/Utils.vala"
					_tmp33_ = _g_object_ref0 (_tmp32_);
#line 53 "../src/Utils.vala"
					_mode_to_check_list = _tmp33_;
#line 53 "../src/Utils.vala"
					_tmp34_ = _mode_to_check_list;
#line 53 "../src/Utils.vala"
					_tmp35_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp34_);
#line 53 "../src/Utils.vala"
					_tmp36_ = _tmp35_;
#line 53 "../src/Utils.vala"
					_mode_to_check_size = _tmp36_;
#line 53 "../src/Utils.vala"
					_mode_to_check_index = -1;
#line 53 "../src/Utils.vala"
					while (TRUE) {
#line 415 "Utils.c"
						gint _tmp37_;
						gint _tmp38_;
						gint _tmp39_;
						DisplayMonitorMode* mode_to_check = NULL;
						GeeLinkedList* _tmp40_;
						gint _tmp41_;
						gpointer _tmp42_;
						gboolean mode_found = FALSE;
						gboolean _tmp69_;
#line 53 "../src/Utils.vala"
						_tmp37_ = _mode_to_check_index;
#line 53 "../src/Utils.vala"
						_mode_to_check_index = _tmp37_ + 1;
#line 53 "../src/Utils.vala"
						_tmp38_ = _mode_to_check_index;
#line 53 "../src/Utils.vala"
						_tmp39_ = _mode_to_check_size;
#line 53 "../src/Utils.vala"
						if (!(_tmp38_ < _tmp39_)) {
#line 53 "../src/Utils.vala"
							break;
#line 437 "Utils.c"
						}
#line 53 "../src/Utils.vala"
						_tmp40_ = _mode_to_check_list;
#line 53 "../src/Utils.vala"
						_tmp41_ = _mode_to_check_index;
#line 53 "../src/Utils.vala"
						_tmp42_ = gee_abstract_list_get ((GeeAbstractList*) _tmp40_, _tmp41_);
#line 53 "../src/Utils.vala"
						mode_to_check = (DisplayMonitorMode*) _tmp42_;
#line 54 "../src/Utils.vala"
						mode_found = FALSE;
#line 449 "Utils.c"
						{
							GeeLinkedList* _monitor_mode_list = NULL;
							DisplayMonitor* _tmp43_;
							GeeLinkedList* _tmp44_;
							GeeLinkedList* _tmp45_;
							GeeLinkedList* _tmp46_;
							gint _monitor_mode_size = 0;
							GeeLinkedList* _tmp47_;
							gint _tmp48_;
							gint _tmp49_;
							gint _monitor_mode_index = 0;
#line 55 "../src/Utils.vala"
							_tmp43_ = monitor;
#line 55 "../src/Utils.vala"
							_tmp44_ = display_monitor_get_modes (_tmp43_);
#line 55 "../src/Utils.vala"
							_tmp45_ = _tmp44_;
#line 55 "../src/Utils.vala"
							_tmp46_ = _g_object_ref0 (_tmp45_);
#line 55 "../src/Utils.vala"
							_monitor_mode_list = _tmp46_;
#line 55 "../src/Utils.vala"
							_tmp47_ = _monitor_mode_list;
#line 55 "../src/Utils.vala"
							_tmp48_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp47_);
#line 55 "../src/Utils.vala"
							_tmp49_ = _tmp48_;
#line 55 "../src/Utils.vala"
							_monitor_mode_size = _tmp49_;
#line 55 "../src/Utils.vala"
							_monitor_mode_index = -1;
#line 55 "../src/Utils.vala"
							while (TRUE) {
#line 483 "Utils.c"
								gint _tmp50_;
								gint _tmp51_;
								gint _tmp52_;
								DisplayMonitorMode* monitor_mode = NULL;
								GeeLinkedList* _tmp53_;
								gint _tmp54_;
								gpointer _tmp55_;
								gboolean _tmp56_ = FALSE;
								DisplayMonitorMode* _tmp57_;
								gint _tmp58_;
								gint _tmp59_;
								DisplayMonitorMode* _tmp60_;
								gint _tmp61_;
								gint _tmp62_;
#line 55 "../src/Utils.vala"
								_tmp50_ = _monitor_mode_index;
#line 55 "../src/Utils.vala"
								_monitor_mode_index = _tmp50_ + 1;
#line 55 "../src/Utils.vala"
								_tmp51_ = _monitor_mode_index;
#line 55 "../src/Utils.vala"
								_tmp52_ = _monitor_mode_size;
#line 55 "../src/Utils.vala"
								if (!(_tmp51_ < _tmp52_)) {
#line 55 "../src/Utils.vala"
									break;
#line 510 "Utils.c"
								}
#line 55 "../src/Utils.vala"
								_tmp53_ = _monitor_mode_list;
#line 55 "../src/Utils.vala"
								_tmp54_ = _monitor_mode_index;
#line 55 "../src/Utils.vala"
								_tmp55_ = gee_abstract_list_get ((GeeAbstractList*) _tmp53_, _tmp54_);
#line 55 "../src/Utils.vala"
								monitor_mode = (DisplayMonitorMode*) _tmp55_;
#line 56 "../src/Utils.vala"
								_tmp57_ = mode_to_check;
#line 56 "../src/Utils.vala"
								_tmp58_ = display_monitor_mode_get_width (_tmp57_);
#line 56 "../src/Utils.vala"
								_tmp59_ = _tmp58_;
#line 56 "../src/Utils.vala"
								_tmp60_ = monitor_mode;
#line 56 "../src/Utils.vala"
								_tmp61_ = display_monitor_mode_get_width (_tmp60_);
#line 56 "../src/Utils.vala"
								_tmp62_ = _tmp61_;
#line 56 "../src/Utils.vala"
								if (_tmp59_ == _tmp62_) {
#line 534 "Utils.c"
									DisplayMonitorMode* _tmp63_;
									gint _tmp64_;
									gint _tmp65_;
									DisplayMonitorMode* _tmp66_;
									gint _tmp67_;
									gint _tmp68_;
#line 57 "../src/Utils.vala"
									_tmp63_ = mode_to_check;
#line 57 "../src/Utils.vala"
									_tmp64_ = display_monitor_mode_get_height (_tmp63_);
#line 57 "../src/Utils.vala"
									_tmp65_ = _tmp64_;
#line 57 "../src/Utils.vala"
									_tmp66_ = monitor_mode;
#line 57 "../src/Utils.vala"
									_tmp67_ = display_monitor_mode_get_height (_tmp66_);
#line 57 "../src/Utils.vala"
									_tmp68_ = _tmp67_;
#line 57 "../src/Utils.vala"
									_tmp56_ = _tmp65_ == _tmp68_;
#line 555 "Utils.c"
								} else {
#line 56 "../src/Utils.vala"
									_tmp56_ = FALSE;
#line 559 "Utils.c"
								}
#line 56 "../src/Utils.vala"
								if (_tmp56_) {
#line 58 "../src/Utils.vala"
									mode_found = TRUE;
#line 59 "../src/Utils.vala"
									_g_object_unref0 (monitor_mode);
#line 59 "../src/Utils.vala"
									break;
#line 569 "Utils.c"
								}
#line 55 "../src/Utils.vala"
								_g_object_unref0 (monitor_mode);
#line 573 "Utils.c"
							}
#line 55 "../src/Utils.vala"
							_g_object_unref0 (_monitor_mode_list);
#line 577 "Utils.c"
						}
#line 63 "../src/Utils.vala"
						_tmp69_ = mode_found;
#line 63 "../src/Utils.vala"
						if (_tmp69_ == FALSE) {
#line 583 "Utils.c"
							GeeLinkedList* _tmp70_;
							DisplayMonitorMode* _tmp71_;
#line 64 "../src/Utils.vala"
							_tmp70_ = to_remove;
#line 64 "../src/Utils.vala"
							_tmp71_ = mode_to_check;
#line 64 "../src/Utils.vala"
							gee_abstract_collection_add ((GeeAbstractCollection*) _tmp70_, _tmp71_);
#line 592 "Utils.c"
						}
#line 53 "../src/Utils.vala"
						_g_object_unref0 (mode_to_check);
#line 596 "Utils.c"
					}
#line 53 "../src/Utils.vala"
					_g_object_unref0 (_mode_to_check_list);
#line 600 "Utils.c"
				}
#line 68 "../src/Utils.vala"
				_tmp72_ = common_modes;
#line 68 "../src/Utils.vala"
				_tmp73_ = to_remove;
#line 68 "../src/Utils.vala"
				gee_collection_remove_all ((GeeCollection*) _tmp72_, (GeeCollection*) _tmp73_);
#line 43 "../src/Utils.vala"
				_g_object_unref0 (to_remove);
#line 610 "Utils.c"
			}
#line 42 "../src/Utils.vala"
			_g_object_unref0 (monitor);
#line 614 "Utils.c"
		}
#line 42 "../src/Utils.vala"
		_g_object_unref0 (_monitor_list);
#line 618 "Utils.c"
	}
#line 72 "../src/Utils.vala"
	result = common_modes;
#line 72 "../src/Utils.vala"
	return result;
#line 624 "Utils.c"
}


gdouble
display_utils_get_min_compatible_scale (GeeLinkedList* monitors)
{
	gdouble result = 0.0;
	gdouble min_scale = 0.0;
#line 75 "../src/Utils.vala"
	g_return_val_if_fail (monitors != NULL, 0.0);
#line 76 "../src/Utils.vala"
	min_scale = DBL_MAX;
#line 637 "Utils.c"
	{
		GeeLinkedList* _monitor_list = NULL;
		GeeLinkedList* _tmp0_;
		gint _monitor_size = 0;
		GeeLinkedList* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		gint _monitor_index = 0;
#line 77 "../src/Utils.vala"
		_tmp0_ = _g_object_ref0 (monitors);
#line 77 "../src/Utils.vala"
		_monitor_list = _tmp0_;
#line 77 "../src/Utils.vala"
		_tmp1_ = _monitor_list;
#line 77 "../src/Utils.vala"
		_tmp2_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp1_);
#line 77 "../src/Utils.vala"
		_tmp3_ = _tmp2_;
#line 77 "../src/Utils.vala"
		_monitor_size = _tmp3_;
#line 77 "../src/Utils.vala"
		_monitor_index = -1;
#line 77 "../src/Utils.vala"
		while (TRUE) {
#line 662 "Utils.c"
			gint _tmp4_;
			gint _tmp5_;
			gint _tmp6_;
			DisplayMonitor* monitor = NULL;
			GeeLinkedList* _tmp7_;
			gint _tmp8_;
			gpointer _tmp9_;
			gdouble _tmp10_;
			DisplayMonitor* _tmp11_;
#line 77 "../src/Utils.vala"
			_tmp4_ = _monitor_index;
#line 77 "../src/Utils.vala"
			_monitor_index = _tmp4_ + 1;
#line 77 "../src/Utils.vala"
			_tmp5_ = _monitor_index;
#line 77 "../src/Utils.vala"
			_tmp6_ = _monitor_size;
#line 77 "../src/Utils.vala"
			if (!(_tmp5_ < _tmp6_)) {
#line 77 "../src/Utils.vala"
				break;
#line 684 "Utils.c"
			}
#line 77 "../src/Utils.vala"
			_tmp7_ = _monitor_list;
#line 77 "../src/Utils.vala"
			_tmp8_ = _monitor_index;
#line 77 "../src/Utils.vala"
			_tmp9_ = gee_abstract_list_get ((GeeAbstractList*) _tmp7_, _tmp8_);
#line 77 "../src/Utils.vala"
			monitor = (DisplayMonitor*) _tmp9_;
#line 78 "../src/Utils.vala"
			_tmp10_ = min_scale;
#line 78 "../src/Utils.vala"
			_tmp11_ = monitor;
#line 78 "../src/Utils.vala"
			min_scale = MIN (_tmp10_, display_monitor_get_max_scale (_tmp11_));
#line 77 "../src/Utils.vala"
			_g_object_unref0 (monitor);
#line 702 "Utils.c"
		}
#line 77 "../src/Utils.vala"
		_g_object_unref0 (_monitor_list);
#line 706 "Utils.c"
	}
#line 81 "../src/Utils.vala"
	result = min_scale;
#line 81 "../src/Utils.vala"
	return result;
#line 712 "Utils.c"
}



